<?php

namespace App\Http\Controllers\Admin\Accounts;

use App\BalanceTransfer;
use App\PaymentTypes;
use App\Http\Controllers\Controller;
use Illuminate\Http\Request;

use Auth;
use App\UserPermission;

class BalanceTransferController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        // if(Auth::user()->getRole->admin==1 || Auth::user()->getRole->read==1 && isset(UserPermission::where('user_id', Auth::user()->id)->first()->accounts)){
        //     $balance_transfer = BalanceTransfer::orderBy('id', 'desc')->paginate(50);
        //     return view('admin.accounts.balance_transfer.index', compact('balance_transfer'));
        // }else{
        //     $permission="'Read Level' permission needed!!!";
        //     return view('admin.notify.permission_denied', compact('permission'));
        // }
        
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        if(Auth::user()->getRole->admin==1 || Auth::user()->getRole->create==1 && isset(UserPermission::where('user_id', Auth::user()->id)->first()->accounts)){
            $balance_transfer_all = BalanceTransfer::orderBy('id', 'desc')->paginate(50);
            return view('admin.accounts.balance_transfer.create', compact('balance_transfer_all'));
        }else{
            $permission="'Create Level' permission needed!!!";
            return view('admin.notify.permission_denied', compact('permission'));
        }
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        if(Auth::user()->getRole->admin==1 || Auth::user()->getRole->create==1 && isset(UserPermission::where('user_id', Auth::user()->id)->first()->accounts)){
            $this->validate($request, [
                'date'  => 'required',
                'transfer_from_id' => 'required',
                'transfer_to_id' => 'required',
                'balance_transfer_amount' => 'required',
            ]);
            $requestData = $request->all();
            $requestData['created_by_id']=Auth::user()->id;
            if (isset($request->transfer_from_id) && isset($request->transfer_to_id) && isset($request->balance_transfer_amount)) {
                $transfer_from=PaymentTypes::findOrFail($request->transfer_from_id);
                $transfer_to=PaymentTypes::findOrFail($request->transfer_to_id);
                $transfer_from_balance = (isset($transfer_from->incoming_balance)?$transfer_from->incoming_balance:'0')-($request->balance_transfer_amount);
                $transfer_to_balance = (isset($transfer_to->incoming_balance)?$transfer_to->incoming_balance:'0')+($request->balance_transfer_amount);
                $transferFromData['incoming_balance'] = $transfer_from_balance;
                $transferToData['incoming_balance'] = $transfer_to_balance;
                if (isset($transfer_from->incoming_balance) && $transfer_from->incoming_balance >= $request->balance_transfer_amount) {
                    $transfer_from->update($transferFromData);
                    $transfer_to->update($transferToData);
    
                    BalanceTransfer::create($requestData);
                    return redirect()->back()->with('message', 'Successfully balance transfered!');
                }else {
                    return redirect()->back()->with('message', 'Insufficient Balance');
                }
            }
        }else{
            $permission="'Create Level' permission needed!!!";
            return view('admin.notify.permission_denied', compact('permission'));
        }
    }

    /**
     * Display the specified resource.
     *
     * @param  \App\BalanceTransfer  $balance_transfer
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        // if(Auth::user()->getRole->admin==1 || Auth::user()->getRole->read==1 && isset(UserPermission::where('user_id', Auth::user()->id)->first()->accounts)){
        //     $balance_transfer = BalanceTransfer::findOrFail($id);
        //     $balance_transfer=isset($balance_transfer)?$balance_transfer->getBalanceTransfer:null;
        //     return view('admin.accounts.balance_transfer.show', compact('balance_transfer','balance_transfer'));
        // }else{
        //     $permission="'Read Level' permission needed!!!";
        //     return view('admin.notify.permission_denied', compact('permission'));
        // }
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  \App\BalanceTransfer  $balance_transfer
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        // if(Auth::user()->getRole->admin==1 || Auth::user()->getRole->update==1 && isset(UserPermission::where('user_id', Auth::user()->id)->first()->accounts)){
        //     $balance_transfer = BalanceTransfer::findOrFail($id);
        //     $balance_transfer_all = BalanceTransfer::orderBy('id', 'desc')->paginate(50);
        //     return view('admin.accounts.balance_transfer.edit', compact('balance_transfer', 'balance_transfer_all'));
        // }else{
        //     $permission="'Update Level' permission needed!!!";
        //     return view('admin.notify.permission_denied', compact('permission'));
        // }
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  \App\BalanceTransfer  $balance_transfer
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        // if(Auth::user()->getRole->admin==1 || Auth::user()->getRole->update==1 && isset(UserPermission::where('user_id', Auth::user()->id)->first()->accounts)){
        //     $this->validate($request, [
        //         'transfer_from_id' => 'required',
        //         'transfer_to_id' => 'required',
        //         'balance_transfer_amount' => 'required',
        //         'date'  => 'required',
        //     ]);
        //     $requestData = $request->only('created_by_id', 'transfer_from_id', 'date', 'amount', 'note', 'status');
        //     $requestData['created_by_id']=Auth::user()->id;
        //     $balance_transfer = BalanceTransfer::findOrFail($id);
        //     $balance_transfer->update($requestData);

        //     return redirect()->back()->with('message', 'Successfully balance_transfer Updated!');
        // }else{
        //     $permission="'Update Level' permission needed!!!";
        //     return view('admin.notify.permission_denied', compact('permission'));
        // }
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  \App\BalanceTransfer  $balance_transfer
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        // if(Auth::user()->getRole->admin==1 || Auth::user()->getRole->delete==1 && isset(UserPermission::where('user_id', Auth::user()->id)->first()->accounts)){
        //     BalanceTransfer::destroy($id);
        //     return redirect('admin/accounts/balance_transfer');
        // }else{
        //     $permission="'Delete Level' permission needed!!!";
        //     return view('admin.notify.permission_denied', compact('permission'));
        // }
    }

    public function allDelete(){
        if(Auth::user()->getRole->admin==1 && isset(UserPermission::where('user_id', Auth::user()->id)->first()->accounts)){
            BalanceTransfer::whereNotNull('id')->delete();
            return redirect('admin/accounts/balance_transfer');
        }else{
            $permission="'Admin Level' permission needed!!!";
            return view('admin.notify.permission_denied', compact('permission'));
        }
    }
    
}
