<?php

namespace App\Http\Controllers\Admin\Accounts;

use App\ClientBalance;
use App\Client;
use App\Payment;
use App\PaymentTypes;
use App\Accounting;
use App\SMS;
use App\Http\Controllers\Controller;
use Illuminate\Http\Request;

use Auth;
use App\UserPermission;

class ClientBalanceController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        
        // if(Auth::user()->getRole->admin==1 || Auth::user()->getRole->read==1 && isset(UserPermission::where('user_id', Auth::user()->id)->first()->accounts)){
        //     $client_balance = ClientBalance::orderBy('id', 'desc')->paginate(50);
        //     return view('admin.accounts.client_balance.index', compact('client_balance'));
        // }else{
        //     $permission="'Read Level' permission needed!!!";
        //     return view('admin.notify.permission_denied', compact('permission'));
        // }
        
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        if(Auth::user()->getRole->admin==1 || Auth::user()->getRole->create==1 && isset(UserPermission::where('user_id', Auth::user()->id)->first()->accounts)){
            $client_balance_all = ClientBalance::orderBy('id', 'desc')->paginate(50);
            return view('admin.accounts.client_balance.create', compact('client_balance_all'));
        }else{
            $permission="'Create Level' permission needed!!!";
            return view('admin.notify.permission_denied', compact('permission'));
        }
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        if(Auth::user()->getRole->admin==1 || Auth::user()->getRole->create==1 && isset(UserPermission::where('user_id', Auth::user()->id)->first()->accounts)){
            $this->validate($request, [
                'client_id' => 'required',
                'amount' => 'required',
                'date'  => 'required',
                'payment_type_id'  => 'required',
            ]);
            $requestData = $request->only('created_by_id', 'client_id', 'payment_type_id', 'date', 'amount', 'note', 'type', 'status');
            $requestData['created_by_id']=Auth::user()->id;
            $balanceClient=Client::findOrFail($requestData['client_id']);
            $requestData['old_balance'] = $balanceClient->balance;
            $requestData['old_due'] = $balanceClient->due;
            $clientBalanceData = ClientBalance::create($requestData);

            // payment
            $paymentData['date']=$clientBalanceData->date;
            $paymentData['created_by_id']=$clientBalanceData->created_by_id;
            $paymentData['client_id']=$clientBalanceData->client_id;
            $paymentData['invoice_id']=$clientBalanceData->id;
            $paymentData['payment_type_id']=$request->input('payment_type_id');
            $paymentData['payment_amount']=$request->input('amount');
            $paymentData['payment_note']='Client Balance - '.$request->input('note');
            if (isset($paymentData['payment_type_id']) && isset($paymentData['payment_amount']) && $clientBalanceData->type=='IN') {
                $balance=(isset($balanceClient->balance)?$balanceClient->balance:'0')+($paymentData['payment_amount']);
                $due=isset($balanceClient->due)?$balanceClient->due:'0';
                if ($balance>$due) {
                    $balanceClientData['balance']=$balance-$due;
                    $balanceClientData['due']=0;
                }else {
                    $balanceClientData['balance']=0;
                    $balanceClientData['due']=$due-$balance;
                }
                
                if ($balanceClient->type=='supplier') {
                    $balance=PaymentTypes::findOrFail($paymentData['payment_type_id']);
                    $balanceClient->update($balanceClientData);
                    $paymentData['payment_category']='Client-Balance-Payment-IN';
                    $paymentData['type']='OUT';
                    $payment=Payment::create($paymentData);

                    $outgoing_balance = (isset($balance->outgoing_balance)?$balance->outgoing_balance:'0')+($paymentData['payment_amount']);
                    $paymentTypesDate['outgoing_balance'] = $outgoing_balance;
                    $balance->update($paymentTypesDate);
                }else {
                    $balanceClient->update($balanceClientData);
                    $paymentData['payment_category']='Client-Balance-Payment-IN';
                    $paymentData['type']='IN';
                    $payment=Payment::create($paymentData);

                    $balance=PaymentTypes::findOrFail($paymentData['payment_type_id']);
                    $incoming_balance = (isset($balance->incoming_balance)?$balance->incoming_balance:'0')+($paymentData['payment_amount']);
                    $paymentTypesDate['incoming_balance'] = $incoming_balance;
                    $balance->update($paymentTypesDate);
                }

                //accounting record
                $accountingData['created_by_id']=$payment->created_by_id;
                $accountingData['client_id']=$payment->client_id;
                $accountingData['ref_id']=$payment->id;
                $accountingData['date']=$payment->date;
                $accountingData['debit']=$payment->payment_amount; // paid
                $accountingData['credit']=0; //payable
                $accountingData['balance']=$accountingData['debit']-$accountingData['credit'];
                $accountingData['description']='Client-Balance-Payment-IN';
                $accountingData['note']=$payment->payment_note;
                $accounting=Accounting::create($accountingData);

                //SMS sending section start
                if ($request->sms==1) {
                    $smsData['created_by_id']=$clientBalanceData->created_by_id;
                    $smsData['Title']='Balance IN '.isset($clientBalanceData->getClient->title)?$clientBalanceData->getClient->title:'';
                    $smsData['number']=isset($clientBalanceData->getClient->phone)?$clientBalanceData->getClient->phone:'';
                    $smsTemplateClient=isset($clientBalanceData->getClient)?$clientBalanceData->getClient->title:null;
                    $smsData['message']='Dealer: M/S CloudBari Traders, Balance IN to '.$smsTemplateClient.' Old due balance:'.$requestData['old_due'].' BDT, Paid: '.$clientBalanceData->amount.' BDT, Total due balance: '.$balanceClientData['due'].' BDT, Total current balance: '.$balanceClientData['balance'].' BDT, Date: '.$paymentData['date'];
                    $smsResult=SMS::getSMS($smsData['number'], $smsData['message']);
                    if ($smsResult['status']=="SENT") {
                        SMS::create($smsData);
                    }
                }
                //SMS sending section end

            }elseif (isset($paymentData['payment_type_id']) && isset($paymentData['payment_amount']) && $clientBalanceData->type=='OUT') {
                $balance=(isset($balanceClient->balance)?$balanceClient->balance:'0')-($paymentData['payment_amount']);
                if ($balance>0) {
                    $balanceClientData['balance']=$balance;
                    $balanceClient->update($balanceClientData);
                    
                    if ($balanceClient->type=='supplier') {
                        $paymentData['payment_category']='Client-Balance-Payment-OUT';
                        $paymentData['type']='IN';
                        $payment=Payment::create($paymentData);

                        $balance=PaymentTypes::findOrFail($paymentData['payment_type_id']);
                        $incoming_balance = (isset($balance->incoming_balance)?$balance->incoming_balance:'0')+($paymentData['payment_amount']);
                        $paymentTypesDate['incoming_balance'] = $incoming_balance;
                        $balance->update($paymentTypesDate);
                    }else {
                        $paymentData['payment_category']='Client-Balance-Payment-OUT';
                        $paymentData['type']='OUT';
                        $payment=Payment::create($paymentData);

                        $balance=PaymentTypes::findOrFail($paymentData['payment_type_id']);
                        $outgoing_balance = (isset($balance->outgoing_balance)?$balance->outgoing_balance:'0')+($paymentData['payment_amount']);
                        $paymentTypesDate['outgoing_balance'] = $outgoing_balance;
                        $balance->update($paymentTypesDate);
                    }

                    //accounting record
                    $accountingData['created_by_id']=$payment->created_by_id;
                    $accountingData['client_id']=$payment->client_id;
                    $accountingData['ref_id']=$payment->id;
                    $accountingData['date']=$payment->date;
                    $accountingData['debit']=0; // paid
                    $accountingData['credit']=$payment->payment_amount; //payable
                    $accountingData['balance']=$accountingData['debit']-$accountingData['credit'];
                    $accountingData['description']='Client-Balance-Payment-OUT';
                    $accountingData['note']=$payment->payment_note;
                    $accounting=Accounting::create($accountingData);

                    //SMS sending section start
                    if ($request->sms==1) {
                        $smsData['created_by_id']=$clientBalanceData->created_by_id;
                        $smsData['Title']='Balance OUT '.isset($clientBalanceData->getClient->title)?$clientBalanceData->getClient->title:'';
                        $smsData['number']=isset($clientBalanceData->getClient->phone)?$clientBalanceData->getClient->phone:'';
                        $smsTemplateClient=isset($clientBalanceData->getClient->title)?$clientBalanceData->getClient->title:null;
                        $smsData['message']='Dealer: M/S CloudBari Traders, Balance OUT from '.$smsTemplateClient.'. Old due balance:'.$requestData['old_due'].' BDT, Paid: '.$clientBalanceData->amount.' BDT, Total due balance: '.$balanceClientData['due'].' BDT, Total current balance: '.$balanceClientData['balance'].' BDT, Date: '.$paymentData['date'];
                        $smsResult=SMS::getSMS($smsData['number'], $smsData['message']);
                        if ($smsResult['status']=="SENT") {
                            SMS::create($smsData);
                        }
                    }
                    //SMS sending section end
                }else {
                    return redirect()->back()->with('message', 'Insaficient Client Balance!');
                }
                

            }elseif (isset($paymentData['payment_type_id']) && isset($paymentData['payment_amount']) && $clientBalanceData->type=='DUE') {
                $balance=(isset($balanceClient->balance)?$balanceClient->balance:'0');
                $due=(isset($balanceClient->due)?$balanceClient->due:'0')+($paymentData['payment_amount']);
                if ($balance>$due) {
                    $balanceClientData['balance']=$balance-$due;
                    $balanceClientData['due']=0;
                }else {
                    $balanceClientData['balance']=0;
                    $balanceClientData['due']=$due-$balance;
                }
                
                if ($balanceClient->type=='supplier') {
                    $balance=PaymentTypes::findOrFail($paymentData['payment_type_id']);
                    $balanceClient->update($balanceClientData);
                    $paymentData['payment_category']='Client-Balance-Payment-DUE';
                    $paymentData['type']='IN';
                    $payment=Payment::create($paymentData);
                    
                    $incoming_balance = (isset($balance->incoming_balance)?$balance->incoming_balance:'0')+($paymentData['payment_amount']);
                    $paymentTypesDate['incoming_balance'] = $incoming_balance;
                    $balance->update($paymentTypesDate);
                }else {
                    $balance=PaymentTypes::findOrFail($paymentData['payment_type_id']);
                    $balanceClient->update($balanceClientData);
                    $paymentData['payment_category']='Client-Balance-Payment-DUE';
                    $paymentData['type']='OUT';
                    $payment=Payment::create($paymentData);
                    
                    $outgoing_balance = (isset($balance->outgoing_balance)?$balance->outgoing_balance:'0')+($paymentData['payment_amount']);
                    $paymentTypesDate['outgoing_balance'] = $outgoing_balance;
                    $balance->update($paymentTypesDate);
                }
                
                //accounting record
                $accountingData['created_by_id']=$payment->created_by_id;
                $accountingData['client_id']=$payment->client_id;
                $accountingData['ref_id']=$payment->id;
                $accountingData['date']=$payment->date;
                $accountingData['debit']=0; // paid
                $accountingData['credit']=$payment->payment_amount; //payable
                $accountingData['balance']=$accountingData['debit']-$accountingData['credit'];
                $accountingData['description']='Client-Balance-Payment-DUE';
                $accountingData['note']=$payment->payment_note;
                $accounting=Accounting::create($accountingData);

                //SMS sending section start
                if ($request->sms==1) {
                    $smsData['created_by_id']=$clientBalanceData->created_by_id;
                    $smsData['Title']='MAKE DUE- '.isset($clientBalanceData->getClient->title)?$clientBalanceData->getClient->title:'';
                    $smsData['number']=isset($clientBalanceData->getClient->phone)?$clientBalanceData->getClient->phone:'';
                    $smsTemplateClient=isset($clientBalanceData->getClient->title)?$clientBalanceData->getClient->title:null;
                    $smsData['message']='Dealer: M/S CloudBari Traders, Make due to '.$smsTemplateClient.'. Old due balance:'.$requestData['old_due'].' BDT, Paid: '.$clientBalanceData->amount.' BDT, Total due balance:: '.$balanceClientData['due'].' BDT, Total current balance: '.$balanceClientData['balance'].' BDT, Date: '.$paymentData['date'];
                    $smsResult=SMS::getSMS($smsData['number'], $smsData['message']);
                    if ($smsResult['status']=="SENT") {
                        SMS::create($smsData);
                    }
                }
                //SMS sending section end

            }

            return redirect()->back()->with('message', 'Successfully Client Balance Submited!');
        }else{
            $permission="'Create Level' permission needed!!!";
            return view('admin.notify.permission_denied', compact('permission'));
        }
    }

    /**
     * Display the specified resource.
     *
     * @param  \App\ClientBalance  $client_balance
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        if(Auth::user()->getRole->admin==1 || Auth::user()->getRole->read==1 && isset(UserPermission::where('user_id', Auth::user()->id)->first()->accounts)){
            $client_balance = ClientBalance::findOrFail($id);
            return view('admin.accounts.client_balance.show', compact('client_balance'));
        }else{
            $permission="'Read Level' permission needed!!!";
            return view('admin.notify.permission_denied', compact('permission'));
        }
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  \App\ClientBalance  $client_balance
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        // if(Auth::user()->getRole->admin==1 || Auth::user()->getRole->update==1 && isset(UserPermission::where('user_id', Auth::user()->id)->first()->accounts)){
        //     $client_balance = ClientBalance::findOrFail($id);
        //     $client_balance_all = ClientBalance::orderBy('id', 'desc')->paginate(50);
        //     return view('admin.accounts.client_balance.edit', compact('client_balance', 'client_balance_category', 'client_balance_all'));
        // }else{
        //     $permission="'Update Level' permission needed!!!";
        //     return view('admin.notify.permission_denied', compact('permission'));
        // }
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  \App\ClientBalance  $client_balance
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        // if(Auth::user()->getRole->admin==1 || Auth::user()->getRole->update==1 && isset(UserPermission::where('user_id', Auth::user()->id)->first()->accounts)){
        //     $this->validate($request, [
        //         'client_balance_category_id' => 'required',
        //         'amount' => 'required',
        //         'date'  => 'required',
        //     ]);
        //     $requestData = $request->only('created_by_id', 'client_balance_category_id', 'date', 'amount', 'note', 'status');
        //     $requestData['created_by_id']=Auth::user()->id;
        //     $client_balance = ClientBalance::findOrFail($id);
        //     $client_balance->update($requestData);

        //     return redirect()->back()->with('message', 'Successfully client_balance Updated!');
        // }else{
        //     $permission="'Update Level' permission needed!!!";
        //     return view('admin.notify.permission_denied', compact('permission'));
        // }
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  \App\ClientBalance  $client_balance
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        // if(Auth::user()->getRole->admin==1 || Auth::user()->getRole->delete==1 && isset(UserPermission::where('user_id', Auth::user()->id)->first()->accounts)){
        //     ClientBalance::destroy($id);
        //     return redirect('admin/accounts/client_balance');
        // }else{
        //     $permission="'Delete Level' permission needed!!!";
        //     return view('admin.notify.permission_denied', compact('permission'));
        // }
    }

    public function allDelete(){
        if(Auth::user()->getRole->admin==1 && isset(UserPermission::where('user_id', Auth::user()->id)->first()->accounts)){
            ClientBalance::whereNotNull('id')->delete();
            return redirect('admin/accounts/client_balance');
        }else{
            $permission="'Admin Level' permission needed!!!";
            return view('admin.notify.permission_denied', compact('permission'));
        }
    }

    public function advanceSearchIndex(Request $request)
    {
        if(Auth::user()->getRole->admin==1 || Auth::user()->getRole->read==1 && isset(UserPermission::where('user_id', Auth::user()->id)->first()->accounts)){
            $requestData = $request;
            $dbQuery = ClientBalance::query();
            if ($request->client_id!='') {
                $dbQuery->where('client_id', $request->client_id);
            }
            if ($request->date_from!='' && $request->date_to!='') {
                $dbQuery->whereBetween('date', [$request->date_from, $request->date_to]);
            }
            $client_balance_all = $dbQuery->get();
            return view('admin.accounts.client_balance.create', compact('client_balance_all'));
        }else{
            $permission="'Read Level' permission needed!!!";
            return view('admin.notify.permission_denied', compact('permission'));
        }
        
    }

    public function setClientData(){
        if(Auth::user()->getRole->admin==1 || Auth::user()->getRole->sell==1 && isset(UserPermission::where('user_id', Auth::user()->id)->first()->accounts)){
            $inputData= array();
            $inputData['client_id']=$_GET['client_id'];
            $data = Client::findOrFail($inputData['client_id']);
            return ['setClientData'=>$data];
        }else{
            $permission="'Sell Level' permission needed!!!";
            return view('admin.notify.permission_denied', compact('permission'));
        }
    }
    
}
