<?php

namespace App\Http\Controllers\Admin\Backup;

use Illuminate\Http\Request;

use App\Http\Controllers\Controller;
use Maatwebsite\Excel\Facades\Excel;
use App\Exports\AllReportMultiSheetExport;

use Auth;
use App\UserPermission;

class AllReportController extends Controller
{
    public function allReportBackup()
    {
        if(Auth::user()->getRole->admin==1 || Auth::user()->getRole->read==1 && isset(UserPermission::where('user_id', Auth::user()->id)->first()->reports)){
            return view('admin.backup.allReport.backup');
        }else{
            $permission="'Read Level' permission needed!!!";
            return view('admin.notify.permission_denied', compact('permission'));
        }
    }
    public function allReportBackupDownload(Request $request)
    {
        if(Auth::user()->getRole->admin==1 || Auth::user()->getRole->read==1 && isset(UserPermission::where('user_id', Auth::user()->id)->first()->reports)){
            if ($request->date_from!='' && $request->date_to!='') {
                return (new AllReportMultiSheetExport($request->date_from, $request->date_to))->download('Backup ['.$request->date_from .' to '. $request->date_to.'].xlsx');
            }
        }else{
            $permission="'Read Level' permission needed!!!";
            return view('admin.notify.permission_denied', compact('permission'));
        }
    }
}
