<?php

namespace App\Http\Controllers\Admin\Backup;

use Auth;

use Carbon\Carbon;
use App\UserPermission;
use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use Maatwebsite\Excel\Facades\Excel;
use App\Exports\SalesMultiSheetExport;

use App\Exports\StockMultiSheetExport;
use App\Exports\PurchaseMultiSheetExport;
use App\Exports\AccountingMultiSheetExport;

class BackupController extends Controller
{
    //export sales
    // public function salesBackup()
    // {
    //     return (new SalesMultiSheetExport(2022))->download('sales.xlsx');
    // }
    public function salesBackup()
    {
        if(Auth::user()->getRole->admin==1 || Auth::user()->getRole->read==1 && isset(UserPermission::where('user_id', Auth::user()->id)->first()->reports)){
            return view('admin.backup.sales.backup');
        }else{
            $permission="'Read Level' permission needed!!!";
            return view('admin.notify.permission_denied', compact('permission'));
        }
    }
    public function salesBackupDownload(Request $request)
    {
        if(Auth::user()->getRole->admin==1 || Auth::user()->getRole->read==1 && isset(UserPermission::where('user_id', Auth::user()->id)->first()->reports)){
            if ($request->date_from!='' && $request->date_to!='') {
                return (new SalesMultiSheetExport($request->date_from, $request->date_to))->download('Sales Backup ['.$request->date_from .' to '. $request->date_to.'].xlsx');
            }
        }else{
            $permission="'Read Level' permission needed!!!";
            return view('admin.notify.permission_denied', compact('permission'));
        }
    }
    
    
    public function purchaseBackup()
    {
        if(Auth::user()->getRole->admin==1 || Auth::user()->getRole->read==1 && isset(UserPermission::where('user_id', Auth::user()->id)->first()->reports)){
            return view('admin.backup.purchase.backup');
        }else{
            $permission="'Read Level' permission needed!!!";
            return view('admin.notify.permission_denied', compact('permission'));
        }
    }
    public function purchaseBackupDownload(Request $request)
    {
        if(Auth::user()->getRole->admin==1 || Auth::user()->getRole->read==1 && isset(UserPermission::where('user_id', Auth::user()->id)->first()->reports)){
            if ($request->date_from!='' && $request->date_to!='') {
                return (new PurchaseMultiSheetExport($request->date_from, $request->date_to))->download('Purchase Backup ['.$request->date_from .' to '. $request->date_to.'].xlsx');
            }
        }else{
            $permission="'Read Level' permission needed!!!";
            return view('admin.notify.permission_denied', compact('permission'));
        }
    }
    
    public function accountingBackup()
    {
        if(Auth::user()->getRole->admin==1 || Auth::user()->getRole->read==1 && isset(UserPermission::where('user_id', Auth::user()->id)->first()->reports)){
            return view('admin.backup.accounting.backup');
        }else{
            $permission="'Read Level' permission needed!!!";
            return view('admin.notify.permission_denied', compact('permission'));
        }
    }
    public function accountingBackupDownload(Request $request)
    {
        if(Auth::user()->getRole->admin==1 || Auth::user()->getRole->read==1 && isset(UserPermission::where('user_id', Auth::user()->id)->first()->reports)){
            if ($request->date_from!='' && $request->date_to!='') {
                return (new AccountingMultiSheetExport($request->date_from, $request->date_to))->download('Accounting Backup ['.$request->date_from .' to '. $request->date_to.'].xlsx');
            }
        }else{
            $permission="'Read Level' permission needed!!!";
            return view('admin.notify.permission_denied', compact('permission'));
        }
    }
    
    public function stockBackup()
    {
        if(Auth::user()->getRole->admin==1 || Auth::user()->getRole->read==1 && isset(UserPermission::where('user_id', Auth::user()->id)->first()->reports)){
            $todayDate = Carbon::now()->format('Y-m-d h:m');
            return (new StockMultiSheetExport())->download('Stock Backup ['.$todayDate.'].xlsx');
        }else{
            $permission="'Read Level' permission needed!!!";
            return view('admin.notify.permission_denied', compact('permission'));
        }
    }
}
