<?php

namespace App\Http\Controllers\Admin\HRM;

use App\Attendance;
use App\Http\Controllers\Controller;
use Illuminate\Http\Request;

use App\Payroll;
use App\Employee;
use Auth;
use App\UserPermission;

class AttendanceController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        if(Auth::user()->getRole->admin==1 || Auth::user()->getRole->read==1 && isset(UserPermission::where('user_id', Auth::user()->id)->first()->hrm)){
            $employee = Employee::all();
            return view('admin.hrm.attendance.index', compact('employee'));
        }else{
            $permission="'Read Level' permission needed!!!";
            return view('admin.notify.permission_denied', compact('permission'));
        }
        
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        // if(Auth::user()->getRole->admin==1 || Auth::user()->getRole->create==1 && isset(UserPermission::where('user_id', Auth::user()->id)->first()->hrm)){
        //     return view('admin.hrm.attendance.create');
        // }else{
        //     $permission="'Create Level' permission needed!!!";
        //     return view('admin.notify.permission_denied', compact('permission'));
        // }
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        // if(Auth::user()->getRole->admin==1 || Auth::user()->getRole->create==1 && isset(UserPermission::where('user_id', Auth::user()->id)->first()->hrm)){
        //     $this->validate($request, [
        //         'title' => 'required|max:50',
        //         'salary' => 'required',
        //         'salary_type' => 'required',
        //         'annual_leave' => 'required',
        //         'loan' => 'required',
        //     ]);
        //     $requestData = $request->all();
        //     $attendance=Attendance::create($requestData);

        //     return redirect()->back()->with('message', 'Successfully attendance Added!');
        // }else{
        //     $permission="'Create Level' permission needed!!!";
        //     return view('admin.notify.permission_denied', compact('permission'));
        // }
    }

    /**
     * Display the specified resource.
     *
     * @param  \App\Attendance  $attendance
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        if(Auth::user()->getRole->admin==1 || Auth::user()->getRole->read==1 && isset(UserPermission::where('user_id', Auth::user()->id)->first()->hrm)){
            $employee = Employee::findOrFail($id);
            $attendance=isset($employee->getAttendance)?$employee->getAttendance:null;
            return view('admin.hrm.attendance.show', compact('attendance', 'employee'));
        }else{
            $permission="'Read Level' permission needed!!!";
            return view('admin.notify.permission_denied', compact('permission'));
        }
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  \App\Attendance  $attendance
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        // if(Auth::user()->getRole->admin==1 || Auth::user()->getRole->update==1 && isset(UserPermission::where('user_id', Auth::user()->id)->first()->hrm)){
        //     $attendance = Attendance::findOrFail($id);
        //     return view('admin.hrm.attendance.edit', compact('attendance'));
        // }else{
        //     $permission="'Update Level' permission needed!!!";
        //     return view('admin.notify.permission_denied', compact('permission'));
        // }
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  \App\Attendance  $attendance
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        // if(Auth::user()->getRole->admin==1 || Auth::user()->getRole->update==1 && isset(UserPermission::where('user_id', Auth::user()->id)->first()->hrm)){
        //     $this->validate($request, [
        //         'title' => 'required|max:50',
        //         'salary' => 'required',
        //         'salary_type' => 'required',
        //         'annual_leave' => 'required',
        //         'loan' => 'required',
        //     ]);
        //     $requestData = $request->all();
        //     $attendance = Attendance::findOrFail($id);
        //     $attendance->update($requestData);

        //     return redirect()->back()->with('message', 'Successfully attendance Updated!');
        // }else{
        //     $permission="'Update Level' permission needed!!!";
        //     return view('admin.notify.permission_denied', compact('permission'));
        // }
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  \App\Attendance  $attendance
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        // if(Auth::user()->getRole->admin==1 || Auth::user()->getRole->delete==1 && isset(UserPermission::where('user_id', Auth::user()->id)->first()->hrm)){
        //     Attendance::destroy($id);
        //     return redirect('admin/hrm/attendance');
        // }else{
        //     $permission="'Delete Level' permission needed!!!";
        //     return view('admin.notify.permission_denied', compact('permission'));
        // }
    }

    public function allDelete(){
        if(Auth::user()->getRole->admin==1 && isset(UserPermission::where('user_id', Auth::user()->id)->first()->hrm)){
            Attendance::whereNotNull('id')->delete();
            return redirect('admin/hrm/attendance');
        }else{
            $permission="'Admin Level' permission needed!!!";
            return view('admin.notify.permission_denied', compact('permission'));
        }
    }

    public function attendanceSubmit()
    {
        if(Auth::user()->getRole->admin==1 || Auth::user()->getRole->create==1 && isset(UserPermission::where('user_id', Auth::user()->id)->first()->hrm)){
            
            $attendanceData['created_by_id']=Auth::user()->id;
            $attendanceData['employee_id']=$_GET['employee_id'];
            $attendanceData['date']=$_GET['date'];
            $attendanceData['status']=$_GET['status'];
            $is_attendance_exist=Attendance::where('employee_id', $attendanceData['employee_id'])
                                            ->where('date', $attendanceData['date'])->first();
            if ($is_attendance_exist==null) {
                $attendance = Attendance::create($attendanceData);
                $employee=isset($attendance->getEmployee)?$attendance->getEmployee:null;
                $salary=isset($employee->salary)?$employee->salary:0;
                $salaryType=isset($employee->salary_type)?$employee->salary_type:0;
                switch ($salaryType) {
                    case 'Monthly':
                        $timestamp = strtotime($attendanceData['date']);
                        $year = date("Y", $timestamp);
                        $month = date("m", $timestamp);
                        $daysOfMonth = cal_days_in_month(CAL_GREGORIAN, $month, $year);
                        $dailySalery=$salary/$daysOfMonth;
                        break;
                    case 'Weekly':
                        $dailySalery=$salary/7;
                        break;
                    
                    default:
                        // daily
                        $dailySalery=$salary;
                        break;
                }
                // payroll create
                $payroll=Payroll::where('employee_id', $attendanceData['employee_id'])
                                ->where('status', null)->first();
                if ($payroll==null) {
                    $payrollData['employee_id']=$attendanceData['employee_id'];
                    $payrollData['basic_salary']=$dailySalery;
                    $payrollData['salary_type']=$salaryType;
                    Payroll::create($payrollData);
                }else{
                    $payrollData['basic_salary']=($payroll->basic_salary)+$dailySalery;
                    $payroll->update($payrollData);
                }
                return ['data'=>"Done"];
            }

        }else{
            $permission="'Read Level' permission needed!!!";
            return view('admin.notify.permission_denied', compact('permission'));
        }
        
    }
    public function attendanceSetStatus()
    {
        if(Auth::user()->getRole->admin==1 || Auth::user()->getRole->create==1 && isset(UserPermission::where('user_id', Auth::user()->id)->first()->hrm)){
            $attendanceData['employee_id']=$_GET['employee_id'];
            $attendanceData['date']=$_GET['date'];
            $is_attendance_exist=Attendance::where('employee_id', $attendanceData['employee_id'])
                                            ->where('date', $attendanceData['date'])->first();
            if ($is_attendance_exist) {
                return ['data'=>"Done"];
            }else {
                return ['data'=>"Record"];
            }
        }else{
            $permission="'Read Level' permission needed!!!";
            return view('admin.notify.permission_denied', compact('permission'));
        }
        
    }
}
