<?php

namespace App\Http\Controllers\Admin\HRM;

use App\Payroll;
use App\Http\Controllers\Controller;
use Illuminate\Http\Request;

use App\Employee;
use Auth;
use App\UserPermission;

class PayrollController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        if(Auth::user()->getRole->admin==1 || Auth::user()->getRole->read==1 && isset(UserPermission::where('user_id', Auth::user()->id)->first()->hrm)){
            $payroll = Payroll::all();
            return view('admin.hrm.payroll.index', compact('payroll'));
        }else{
            $permission="'Read Level' permission needed!!!";
            return view('admin.notify.permission_denied', compact('permission'));
        }
        
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        // if(Auth::user()->getRole->admin==1 || Auth::user()->getRole->create==1 && isset(UserPermission::where('user_id', Auth::user()->id)->first()->hrm)){
        //     return view('admin.hrm.payroll.create');
        // }else{
        //     $permission="'Create Level' permission needed!!!";
        //     return view('admin.notify.permission_denied', compact('permission'));
        // }
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        // if(Auth::user()->getRole->admin==1 || Auth::user()->getRole->create==1 && isset(UserPermission::where('user_id', Auth::user()->id)->first()->hrm)){
        //     $this->validate($request, [
        //         'title' => 'required|max:50',
        //         'salary' => 'required',
        //         'salary_type' => 'required',
        //         'annual_leave' => 'required',
        //         'loan' => 'required',
        //     ]);
        //     $requestData = $request->all();
        //     $payroll=Payroll::create($requestData);

        //     return redirect()->back()->with('message', 'Successfully payroll Added!');
        // }else{
        //     $permission="'Create Level' permission needed!!!";
        //     return view('admin.notify.permission_denied', compact('permission'));
        // }
    }

    /**
     * Display the specified resource.
     *
     * @param  \App\Payroll  $payroll
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        if(Auth::user()->getRole->admin==1 || Auth::user()->getRole->read==1 && isset(UserPermission::where('user_id', Auth::user()->id)->first()->hrm)){
            $payroll = Payroll::findOrFail($id);
            return view('admin.hrm.payroll.show', compact('payroll'));
        }else{
            $permission="'Read Level' permission needed!!!";
            return view('admin.notify.permission_denied', compact('permission'));
        }
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  \App\Payroll  $payroll
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        // if(Auth::user()->getRole->admin==1 || Auth::user()->getRole->update==1 && isset(UserPermission::where('user_id', Auth::user()->id)->first()->hrm)){
        //     $payroll = Payroll::findOrFail($id);
        //     return view('admin.hrm.payroll.edit', compact('payroll'));
        // }else{
        //     $permission="'Update Level' permission needed!!!";
        //     return view('admin.notify.permission_denied', compact('permission'));
        // }
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  \App\Payroll  $payroll
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        if(Auth::user()->getRole->admin==1 || Auth::user()->getRole->update==1 && isset(UserPermission::where('user_id', Auth::user()->id)->first()->hrm)){
            $this->validate($request, [
                'date' => 'required',
            ]);
            $requestData = $request->all();
            $payroll = Payroll::findOrFail($id);
            $requestData['status']="Done";
            $payroll->update($requestData);
            
            // employee loan update
            $employee=isset($payroll->getEmployee)?$payroll->getEmployee:null;
            if ($employee) {
                $employeeData['loan']=(isset($employee->loan)?$employee->loan:0)-($request->loan);
                $employee->update($employeeData);
            }

            return redirect()->back()->with('message', 'Successfully payroll Updated!');
        }else{
            $permission="'Update Level' permission needed!!!";
            return view('admin.notify.permission_denied', compact('permission'));
        }
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  \App\Payroll  $payroll
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        // if(Auth::user()->getRole->admin==1 || Auth::user()->getRole->delete==1 && isset(UserPermission::where('user_id', Auth::user()->id)->first()->hrm)){
        //     Payroll::destroy($id);
        //     return redirect('admin/hrm/payroll');
        // }else{
        //     $permission="'Delete Level' permission needed!!!";
        //     return view('admin.notify.permission_denied', compact('permission'));
        // }
    }

    public function allDelete(){
        if(Auth::user()->getRole->admin==1 && isset(UserPermission::where('user_id', Auth::user()->id)->first()->hrm)){
            Payroll::whereNotNull('id')->delete();
            return redirect('admin/hrm/payroll');
        }else{
            $permission="'Admin Level' permission needed!!!";
            return view('admin.notify.permission_denied', compact('permission'));
        }
    }
    
}
