<?php

namespace App\Http\Controllers\Admin\Messaging;

use App\Http\Controllers\Controller;
use App\SMS;
use Illuminate\Http\Request;

use Auth;
use App\UserPermission;

class SMSController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        // if(Auth::user()->getRole->admin==1 || Auth::user()->getRole->read==1 && isset(UserPermission::where('user_id', Auth::user()->id)->first()->buyer_request)){
        //     $sms = SMS::orderBy('id', 'desc')->paginate(50);
        //     return view('admin.messaging.sms.index', compact('sms'));
        // }else{
        //     $permission="'Read Level' permission needed!!!";
        //     return view('admin.notify.permission_denied', compact('permission'));
        // }
        
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        if(Auth::user()->getRole->admin==1 || Auth::user()->getRole->create==1 && isset(UserPermission::where('user_id', Auth::user()->id)->first()->buyer_request)){
            $sms_all = SMS::orderBy('id', 'desc')->paginate(100);
            return view('admin.messaging.sms.create', compact('sms_all'));
        }else{
            $permission="'Create Level' permission needed!!!";
            return view('admin.notify.permission_denied', compact('permission'));
        }
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        if(Auth::user()->getRole->admin==1 || Auth::user()->getRole->create==1 && isset(UserPermission::where('user_id', Auth::user()->id)->first()->buyer_request)){
            $this->validate($request, [
                'number' => 'required',
                'message' => 'required',
            ]);
            $requestData = $request->all();
            $requestData['created_by_id']=Auth::user()->id;
            $smsResult=SMS::getSMS($request->number, $request->message);
            if ($smsResult['status']=="SENT") {
                SMS::create($requestData);
                return redirect()->back()->with('message', $smsResult['status'].'! '.$smsResult['statusmsg']);
            }else{
                return redirect()->back()->with('message', $smsResult['status'].'! '.$smsResult['statusmsg']);
            }
        }else{
            $permission="'Create Level' permission needed!!!";
            return view('admin.notify.permission_denied', compact('permission'));
        }
    }

    /**
     * Display the specified resource.
     *
     * @param  \App\SMS  $sms
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        // if(Auth::user()->getRole->admin==1 || Auth::user()->getRole->read==1 && isset(UserPermission::where('user_id', Auth::user()->id)->first()->buyer_request)){
        //     $sms = SMS::findOrFail($id);
        //     $sms=isset($sms)?$sms->SMS:null;
        //     return view('admin.messaging.sms.show', compact('sms','sms'));
        // }else{
        //     $permission="'Read Level' permission needed!!!";
        //     return view('admin.notify.permission_denied', compact('permission'));
        // }
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  \App\SMS  $sms
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        // if(Auth::user()->getRole->admin==1 || Auth::user()->getRole->update==1 && isset(UserPermission::where('user_id', Auth::user()->id)->first()->buyer_request)){
        //     $sms = SMS::findOrFail($id);
        //     $sms_all = SMS::orderBy('id', 'desc')->paginate(50);
        //     return view('admin.messaging.sms.edit', compact('sms', 'sms_all'));
        // }else{
        //     $permission="'Update Level' permission needed!!!";
        //     return view('admin.notify.permission_denied', compact('permission'));
        // }
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  \App\SMS  $sms
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        // if(Auth::user()->getRole->admin==1 || Auth::user()->getRole->update==1 && isset(UserPermission::where('user_id', Auth::user()->id)->first()->buyer_request)){
        //     $this->validate($request, [
        //         'transfer_from_id' => 'required',
        //         'transfer_to_id' => 'required',
        //         'sms_amount' => 'required',
        //         'date'  => 'required',
        //     ]);
        //     $requestData = $request->only('created_by_id', 'transfer_from_id', 'date', 'amount', 'note', 'status');
        //     $requestData['created_by_id']=Auth::user()->id;
        //     $sms = SMS::findOrFail($id);
        //     $sms->update($requestData);

        //     return redirect()->back()->with('message', 'Successfully sms Updated!');
        // }else{
        //     $permission="'Update Level' permission needed!!!";
        //     return view('admin.notify.permission_denied', compact('permission'));
        // }
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  \App\SMS  $sms
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        // if(Auth::user()->getRole->admin==1 || Auth::user()->getRole->delete==1 && isset(UserPermission::where('user_id', Auth::user()->id)->first()->buyer_request)){
        //     SMS::destroy($id);
        //     return redirect('admin/messaging/sms');
        // }else{
        //     $permission="'Delete Level' permission needed!!!";
        //     return view('admin.notify.permission_denied', compact('permission'));
        // }
    }

    public function allDelete(){
        if(Auth::user()->getRole->admin==1 && isset(UserPermission::where('user_id', Auth::user()->id)->first()->buyer_request)){
            SMS::whereNotNull('id')->delete();
            return redirect('admin/messaging/sms');
        }else{
            $permission="'Admin Level' permission needed!!!";
            return view('admin.notify.permission_denied', compact('permission'));
        }
    }
}
