<?php

namespace App\Http\Controllers\Admin\Reports;

use App\Http\Controllers\Controller;
use Illuminate\Http\Request;

use Auth;
use App\UserPermission;
use App\BalanceTransfer;
use App\Expense;
use App\Income;

class AccountsController extends Controller
{
    public function accountsExpense()
    {
        if(Auth::user()->getRole->admin==1 || Auth::user()->getRole->read==1 && isset(UserPermission::where('user_id', Auth::user()->id)->first()->reports)){
            return view('admin.reports.accounts.expense');
        }else{
            $permission="'Read Level' permission needed!!!";
            return view('admin.notify.permission_denied', compact('permission'));
        }
        
    }
    public function accountsExpensePrint(Request $request)
    {
        if(Auth::user()->getRole->admin==1 || Auth::user()->getRole->read==1 && isset(UserPermission::where('user_id', Auth::user()->id)->first()->reports)){
            // dd(!empty($a));
            $requestData = $request;
            $dbQuery = Expense::query();
            if ($request->date_from!='' && $request->date_to!='') {
                $dbQuery->whereBetween('date', [$request->date_from, $request->date_to]);
            }
            if ($request->expense_category_id!='') {
                $dbQuery->where('expense_category_id', $request->expense_category_id);
            }
            $expense = $dbQuery->get();
            return view('admin.reports.accounts.expense_print', compact('expense', 'requestData'));
        }else{
            $permission="'Read Level' permission needed!!!";
            return view('admin.notify.permission_denied', compact('permission'));
        }
        
    }

    // accounts income end----------------------

    public function accountsIncome()
    {
        if(Auth::user()->getRole->admin==1 || Auth::user()->getRole->read==1 && isset(UserPermission::where('user_id', Auth::user()->id)->first()->reports)){
            return view('admin.reports.accounts.income');
        }else{
            $permission="'Read Level' permission needed!!!";
            return view('admin.notify.permission_denied', compact('permission'));
        }
        
    }
    public function accountsIncomePrint(Request $request)
    {
        if(Auth::user()->getRole->admin==1 || Auth::user()->getRole->read==1 && isset(UserPermission::where('user_id', Auth::user()->id)->first()->reports)){
            // dd(!empty($a));
            $requestData = $request;
            $dbQuery = Income::query();
            if ($request->date_from!='' && $request->date_to!='') {
                $dbQuery->whereBetween('date', [$request->date_from, $request->date_to]);
            }
            if ($request->income_category_id!='') {
                $dbQuery->where('income_category_id', $request->income_category_id);
            }
            $income = $dbQuery->get();
            return view('admin.reports.accounts.income_print', compact('income', 'requestData'));
        }else{
            $permission="'Read Level' permission needed!!!";
            return view('admin.notify.permission_denied', compact('permission'));
        }
        
    }

    // accounts income end----------------------

    public function accountsBalanceTransfer()
    {
        if(Auth::user()->getRole->admin==1 || Auth::user()->getRole->read==1 && isset(UserPermission::where('user_id', Auth::user()->id)->first()->reports)){
            return view('admin.reports.accounts.balance_transfer');
        }else{
            $permission="'Read Level' permission needed!!!";
            return view('admin.notify.permission_denied', compact('permission'));
        }
        
    }

    public function accountsBalanceTransferPrint(Request $request)
    {
        if(Auth::user()->getRole->admin==1 || Auth::user()->getRole->read==1 && isset(UserPermission::where('user_id', Auth::user()->id)->first()->reports)){
            // dd(!empty($a));
            $requestData = $request;
            $dbQuery = BalanceTransfer::query();
            if ($request->date_from!='' && $request->date_to!='') {
                $dbQuery->whereBetween('date', [$request->date_from, $request->date_to]);
            }
            if ($request->transfer_from_id!='') {
                $dbQuery->where('transfer_from_id', $request->transfer_from_id);
            }
            if ($request->transfer_to_id!='') {
                $dbQuery->where('transfer_to_id', $request->transfer_to_id);
            }
            
            $balance_transfer = $dbQuery->get();
            return view('admin.reports.accounts.balance_transfer_print', compact('balance_transfer', 'requestData'));
        }else{
            $permission="'Read Level' permission needed!!!";
            return view('admin.notify.permission_denied', compact('permission'));
        }
        
    }
    // balance_transfer Product Wise end----------------------
}
