<?php

namespace App\Http\Controllers\Admin\Reports;

use App\Http\Controllers\Controller;
use Illuminate\Http\Request;

use Auth;
use App\UserPermission;
use App\PaymentTypes;
use App\Product;
use App\Client;
use App\Accounting;

class LedgerController extends Controller
{
    public function ledgerBalance()
    {
        if(Auth::user()->getRole->admin==1 || Auth::user()->getRole->read==1 && isset(UserPermission::where('user_id', Auth::user()->id)->first()->reports)){
            return view('admin.reports.ledger.balance');
        }else{
            $permission="'Read Level' permission needed!!!";
            return view('admin.notify.permission_denied', compact('permission'));
        }
        
    }
    public function ledgerBalancePrint(Request $request)
    {
        if(Auth::user()->getRole->admin==1 || Auth::user()->getRole->read==1 && isset(UserPermission::where('user_id', Auth::user()->id)->first()->reports)){
            // dd(!empty($a));
            $requestData = $request;
            $dbQuery = PaymentTypes::query();
            // if ($request->date_from!='' && $request->date_to!='') {
            //     $dbQuery->whereBetween('created_at', [$request->date_from, $request->date_to]);
            // }
            if ($request->payment_type_id!='') {
                $dbQuery->where('id', $request->payment_type_id);
            }
            $balance = $dbQuery->get();
            return view('admin.reports.ledger.balance_print', compact('balance', 'requestData'));
        }else{
            $permission="'Read Level' permission needed!!!";
            return view('admin.notify.permission_denied', compact('permission'));
        }
        
    }

    // ledger balance end----------------------
    
    public function ledgerStock()
    {
        if(Auth::user()->getRole->admin==1 || Auth::user()->getRole->read==1 && isset(UserPermission::where('user_id', Auth::user()->id)->first()->reports)){
            return view('admin.reports.ledger.stock');
        }else{
            $permission="'Read Level' permission needed!!!";
            return view('admin.notify.permission_denied', compact('permission'));
        }
        
    }
    
    public function ledgerStockPrint(Request $request)
    {
        if(Auth::user()->getRole->admin==1 || Auth::user()->getRole->read==1 && isset(UserPermission::where('user_id', Auth::user()->id)->first()->reports)){
            // dd(!empty($a));
            $requestData = $request;
            $dbQuery = Product::query();
            // if ($request->date_from!='' && $request->date_to!='') {
            //     $dbQuery->whereBetween('created_at', [$request->date_from, $request->date_to]);
            // }
            if ($request->category_id!='') {
                $dbQuery->where('category_id', $request->category_id);
            }
            $stock = $dbQuery->get();
            return view('admin.reports.ledger.stock_print', compact('stock', 'requestData'));
        }else{
            $permission="'Read Level' permission needed!!!";
            return view('admin.notify.permission_denied', compact('permission'));
        }
        
    }

    // ledger stock end----------------------
    public function ledgerBrandWiseStock()
    {
        if(Auth::user()->getRole->admin==1 || Auth::user()->getRole->read==1 && isset(UserPermission::where('user_id', Auth::user()->id)->first()->reports)){
            return view('admin.reports.ledger.brandWiseStock');
        }else{
            $permission="'Read Level' permission needed!!!";
            return view('admin.notify.permission_denied', compact('permission'));
        }
        
    }
    
    public function ledgerBrandWiseStockPrint(Request $request)
    {
        if(Auth::user()->getRole->admin==1 || Auth::user()->getRole->read==1 && isset(UserPermission::where('user_id', Auth::user()->id)->first()->reports)){
            // dd(!empty($a));
            $requestData = $request;
            $dbQuery = Product::query();
            if ($request->category_id!='' && $request->brand_id!='') {
                $dbQuery->where('category_id', $request->category_id);
                $dbQuery->where('brand_id', $request->brand_id);
                $stock = $dbQuery->get();
                return view('admin.reports.ledger.brandWiseStock_print', compact('stock', 'requestData'));
            }else{
                return redirect()->back()->with('message', 'Category or Brand not selected!');
            }
        }else{
            $permission="'Read Level' permission needed!!!";
            return view('admin.notify.permission_denied', compact('permission'));
        }
        
    }

    // ledger brand wise stock end----------------------

    public function ledgerStockAlert()
    {
        if(Auth::user()->getRole->admin==1 || Auth::user()->getRole->read==1 && isset(UserPermission::where('user_id', Auth::user()->id)->first()->reports)){
            $products = Product::all();
            return view('admin.reports.ledger.stockAlert', compact('products'));
        }else{
            $permission="'Read Level' permission needed!!!";
            return view('admin.notify.permission_denied', compact('permission'));
        }
        
    }
    // ledger stock alert end----------------------
    
    public function ledgerCustomer()
    {
        if(Auth::user()->getRole->admin==1 || Auth::user()->getRole->read==1 && isset(UserPermission::where('user_id', Auth::user()->id)->first()->reports)){
            return view('admin.reports.ledger.customer');
        }else{
            $permission="'Read Level' permission needed!!!";
            return view('admin.notify.permission_denied', compact('permission'));
        }
        
    }
    public function ledgerCustomerPrint(Request $request)
    {
        if(Auth::user()->getRole->admin==1 || Auth::user()->getRole->read==1 && isset(UserPermission::where('user_id', Auth::user()->id)->first()->reports)){
            // dd(!empty($a));
            $requestData = $request;
            $dbQuery = Client::query();
            // if ($request->date_from!='' && $request->date_to!='') {
            //     $dbQuery->whereBetween('created_at', [$request->date_from, $request->date_to]);
            // }
            $dbQuery->where('type', 'customer');
            if ($request->client_id!='') {
                $dbQuery->where('id', $request->client_id);
            }
            $customer = $dbQuery->get();
            return view('admin.reports.ledger.customer_print', compact('customer', 'requestData'));
        }else{
            $permission="'Read Level' permission needed!!!";
            return view('admin.notify.permission_denied', compact('permission'));
        }
        
    }

    // ledger customer end----------------------
    
    public function ledgerSupplier()
    {
        if(Auth::user()->getRole->admin==1 || Auth::user()->getRole->read==1 && isset(UserPermission::where('user_id', Auth::user()->id)->first()->reports)){
            return view('admin.reports.ledger.supplier');
        }else{
            $permission="'Read Level' permission needed!!!";
            return view('admin.notify.permission_denied', compact('permission'));
        }
        
    }
    public function ledgerSupplierPrint(Request $request)
    {
        if(Auth::user()->getRole->admin==1 || Auth::user()->getRole->read==1 && isset(UserPermission::where('user_id', Auth::user()->id)->first()->reports)){
            // dd(!empty($a));
            $requestData = $request;
            $dbQuery = Client::query();
            // if ($request->date_from!='' && $request->date_to!='') {
            //     $dbQuery->whereBetween('created_at', [$request->date_from, $request->date_to]);
            // }
            $dbQuery->where('type', 'supplier');
            if ($request->client_id!='') {
                $dbQuery->where('id', $request->client_id);
            }
            $supplier = $dbQuery->get();
            return view('admin.reports.ledger.supplier_print', compact('supplier', 'requestData'));
        }else{
            $permission="'Read Level' permission needed!!!";
            return view('admin.notify.permission_denied', compact('permission'));
        }
        
    }

    // ledger supplier end----------------------

    public function ledgerOtherClient()
    {
        if(Auth::user()->getRole->admin==1 || Auth::user()->getRole->read==1 && isset(UserPermission::where('user_id', Auth::user()->id)->first()->reports)){
            return view('admin.reports.ledger.otherClient');
        }else{
            $permission="'Read Level' permission needed!!!";
            return view('admin.notify.permission_denied', compact('permission'));
        }
        
    }
    public function ledgerOtherClientPrint(Request $request)
    {
        if(Auth::user()->getRole->admin==1 || Auth::user()->getRole->read==1 && isset(UserPermission::where('user_id', Auth::user()->id)->first()->reports)){
            // dd(!empty($a));
            $requestData = $request;
            $dbQuery = Client::query();
            // if ($request->date_from!='' && $request->date_to!='') {
            //     $dbQuery->whereBetween('created_at', [$request->date_from, $request->date_to]);
            // }
            $dbQuery->where('type', 'other');
            if ($request->client_id!='') {
                $dbQuery->where('id', $request->client_id);
            }
            $otherClient = $dbQuery->get();
            return view('admin.reports.ledger.otherClient_print', compact('otherClient', 'requestData'));
        }else{
            $permission="'Read Level' permission needed!!!";
            return view('admin.notify.permission_denied', compact('permission'));
        }
        
    }

    // ledger outher client end----------------------
    
    public function ledgerAccounting($client_type)
    {
        if(Auth::user()->getRole->admin==1 || Auth::user()->getRole->read==1 && isset(UserPermission::where('user_id', Auth::user()->id)->first()->reports)){
            return view('admin.reports.ledger.accounting', compact('client_type'));
        }else{
            $permission="'Read Level' permission needed!!!";
            return view('admin.notify.permission_denied', compact('permission'));
        }
        
    }
    public function ledgerAccountingPrint(Request $request)
    {
        if(Auth::user()->getRole->admin==1 || Auth::user()->getRole->read==1 && isset(UserPermission::where('user_id', Auth::user()->id)->first()->reports)){
            $requestData = $request;
            $dbQuery = Accounting::query();
            if ($request->date_from!='' && $request->date_to!='') {
                $dbQuery->whereBetween('date', [$request->date_from, $request->date_to]);
            }
            if ($request->client_id!='') {
                $dbQuery->where('client_id', $request->client_id);
            }
            $accounting = $dbQuery->orderBy('date', 'asc')->get();

            //client balance
            $client=null;
            if ($request->client_id!='') {
                $client=Client::find($request->client_id);
            }

            // previous balance
            $dbQuery = Accounting::query();
            if ($request->date_from!='' && $request->date_to!='' && $request->client_id!='') {
                $dbQuery->where('client_id', $request->client_id);
                $dbQuery->where('date', '<', $request->date_from);
                $sumOfPreviousBalance = $dbQuery->orderBy('date', 'asc')->sum('balance');
            }
            return view('admin.reports.ledger.accounting_print', compact('accounting',
                                                                         'sumOfPreviousBalance', 
                                                                         'client', 
                                                                         'requestData'));
        }else{
            $permission="'Read Level' permission needed!!!";
            return view('admin.notify.permission_denied', compact('permission'));
        }
        
    }

    // ledger supplier end----------------------

    // balance adjustment
    // $accounting=Accounting::where('client_id', '24')->orderBy('id', 'desc')->first();
    // $accountingData['balance']=200;
    // $accounting->update($accountingData);
    // dd($accounting->balance);

    

}
