<?php

namespace App\Http\Controllers\Admin\Reports;

use App\Http\Controllers\Controller;
use Illuminate\Http\Request;

use Auth;
use App\UserPermission;
use App\PaymentTypes;
use App\Payment;
use App\Client;

class PaymentController extends Controller
{
    public function paymentHistory()
    {
        if(Auth::user()->getRole->admin==1 || Auth::user()->getRole->read==1 && isset(UserPermission::where('user_id', Auth::user()->id)->first()->reports)){
            return view('admin.reports.payment.history');
        }else{
            $permission="'Read Level' permission needed!!!";
            return view('admin.notify.permission_denied', compact('permission'));
        }
        
    }
    public function paymentHistoryPrint(Request $request)
    {
        if(Auth::user()->getRole->admin==1 || Auth::user()->getRole->read==1 && isset(UserPermission::where('user_id', Auth::user()->id)->first()->reports)){
            // dd(!empty($a));
            $requestData = $request;
            $dbQuery = Payment::query();
            if ($request->date_from!='' && $request->date_to!='') {
                $dbQuery->whereBetween('date', [$request->date_from, $request->date_to]);
            }
            if ($request->client_id!='') {
                $dbQuery->where('client_id', $request->client_id);
            }
            if ($request->payment_type_id!='') {
                $dbQuery->where('payment_type_id', $request->payment_type_id);
            }
            if ($request->keyword!='') {
                $dbQuery->where('payment_note', 'like', '%'.$request->keyword.'%');
            }
            $history = $dbQuery->orderBy('id', 'desc')->get();
            return view('admin.reports.payment.history_print', compact('history', 'requestData'));
        }else{
            $permission="'Read Level' permission needed!!!";
            return view('admin.notify.permission_denied', compact('permission'));
        }
        
    }

    // payment history end----------------------
    
    public function paymentAccounting()
    {
        if(Auth::user()->getRole->admin==1 || Auth::user()->getRole->read==1 && isset(UserPermission::where('user_id', Auth::user()->id)->first()->reports)){
            return view('admin.reports.payment.accounting');
        }else{
            $permission="'Read Level' permission needed!!!";
            return view('admin.notify.permission_denied', compact('permission'));
        }
        
    }
    public function paymentAccountingPrint(Request $request)
    {
        if(Auth::user()->getRole->admin==1 || Auth::user()->getRole->read==1 && isset(UserPermission::where('user_id', Auth::user()->id)->first()->reports)){
            // Payment Transection
            $requestData = $request;
            $dbQuery = Payment::query();
            if ($request->date_from!='' && $request->date_to!='') {
                $dbQuery->whereBetween('date', [$request->date_from, $request->date_to]);
            }
            if ($request->client_id!='') {
                $dbQuery->where('client_id', $request->client_id);
            }
            if ($request->payment_type_id!='') {
                $dbQuery->where('payment_type_id', $request->payment_type_id);
            }
            if ($request->keyword!='') {
                $dbQuery->where('payment_note', 'like', '%'.$request->keyword.'%');
            }
            $accounting = $dbQuery->orderBy('id', 'desc')->get();

            //client balance
            $client=null;
            if ($request->client_id!='') {
                $client=Client::find($request->client_id);
            }
            return view('admin.reports.payment.accounting_print', compact('accounting',
                                                                         'client', 
                                                                         'requestData'));
        }else{
            $permission="'Read Level' permission needed!!!";
            return view('admin.notify.permission_denied', compact('permission'));
        }
        
    }

    // payment accounting end----------------------
    
}
