<?php

namespace App\Http\Controllers\Admin\Reports;

use App\Http\Controllers\Controller;
use Illuminate\Http\Request;

use Auth;
use App\UserPermission;
use App\PurchaseInvoice;
use App\PurchaseReturnInvoice;
use App\Purchase;
use App\PurchaseReturn;
use App\StockUpdateRecord;

class PurchaseController extends Controller
{
    public function purchaseStatement()
    {
        if(Auth::user()->getRole->admin==1 || Auth::user()->getRole->read==1 && isset(UserPermission::where('user_id', Auth::user()->id)->first()->reports)){
            return view('admin.reports.purchase.statement');
        }else{
            $permission="'Read Level' permission needed!!!";
            return view('admin.notify.permission_denied', compact('permission'));
        }
        
    }
    public function purchaseStatementPrint(Request $request)
    {
        if(Auth::user()->getRole->admin==1 || Auth::user()->getRole->read==1 && isset(UserPermission::where('user_id', Auth::user()->id)->first()->reports)){
            // dd(!empty($a));
            $requestData = $request;
            $type=$request->type;
            if ($type=='purchase') {
                $dbQuery = PurchaseInvoice::query();
                if ($request->date_from!='' && $request->date_to!='') {
                    $dbQuery->whereBetween('date', [$request->date_from, $request->date_to]);
                }
                if ($request->client_id!='') {
                    $dbQuery->where('client_id', $request->client_id);
                }
                if ($request->invoice_id!='') {
                    $dbQuery->where('id', $request->invoice_id);
                }
                if ($request->created_by_id!='') {
                    $dbQuery->where('created_by_id', $request->created_by_id);
                }
                $purchaseInvoice = $dbQuery->get();
                return view('admin.reports.purchase.statement_print', compact('purchaseInvoice', 'requestData'));
            }else{
                $dbQuery = PurchaseReturnInvoice::query();
                if ($request->date_from!='' && $request->date_to!='') {
                    $dbQuery->whereBetween('date', [$request->date_from, $request->date_to]);
                }
                if ($request->client_id!='') {
                    $dbQuery->where('client_id', $request->client_id);
                }
                if ($request->invoice_id!='') {
                    $dbQuery->where('id', $request->invoice_id);
                }
                if ($request->created_by_id!='') {
                    $dbQuery->where('created_by_id', $request->created_by_id);
                }
                $purchaseReturnInvoice = $dbQuery->get();
                return view('admin.reports.purchase.return_statement_print', compact('purchaseReturnInvoice', 'requestData'));
            }
        }else{
            $permission="'Read Level' permission needed!!!";
            return view('admin.notify.permission_denied', compact('permission'));
        }
        
    }

    // purchase statement end----------------------

    public function purchaseProductWise()
    {
        if(Auth::user()->getRole->admin==1 || Auth::user()->getRole->read==1 && isset(UserPermission::where('user_id', Auth::user()->id)->first()->reports)){
            return view('admin.reports.purchase.product_wise');
        }else{
            $permission="'Read Level' permission needed!!!";
            return view('admin.notify.permission_denied', compact('permission'));
        }
        
    }

    public function purchaseProductWisePrint(Request $request)
    {
        if(Auth::user()->getRole->admin==1 || Auth::user()->getRole->read==1 && isset(UserPermission::where('user_id', Auth::user()->id)->first()->reports)){
            // dd(!empty($a));
            $requestData = $request;
            $dbQuery = Purchase::query();
            if ($request->date_from!='' && $request->date_to!='') {
                $dbQuery->whereBetween('date', [$request->date_from, $request->date_to]);
            }
            if ($request->product_id!='') {
                $dbQuery->where('product_id', $request->product_id);
            }
            
            $purchase = $dbQuery->get();
            return view('admin.reports.purchase.product_wise_print', compact('purchase', 'requestData'));
        }else{
            $permission="'Read Level' permission needed!!!";
            return view('admin.notify.permission_denied', compact('permission'));
        }
        
    }
    // purchase Product Wise end----------------------
    
    public function purchaseStockUpdateHistory()
    {
        if(Auth::user()->getRole->admin==1 || Auth::user()->getRole->read==1 && isset(UserPermission::where('user_id', Auth::user()->id)->first()->reports)){
            $stockUpdate = StockUpdateRecord::orderBy('id', 'desc')->paginate(50);
            return view('admin.reports.purchase.stockUpdate', compact('stockUpdate'));
        }else{
            $permission="'Read Level' permission needed!!!";
            return view('admin.notify.permission_denied', compact('permission'));
        }
        
    }
    // Stock Update History end----------------------
}
