<?php

namespace App\Http\Controllers\Admin\Reports;

use Auth;
use App\Sale;

use Carbon\Carbon;
use App\SaleReturn;
use App\SaleInvoice;
use App\UserPermission;
use App\SaleReturnInvoice;
use Illuminate\Http\Request;
use App\Http\Controllers\Controller;

class SalesController extends Controller
{
    public function salesStatement()
    {
        if(Auth::user()->getRole->admin==1 || Auth::user()->getRole->read==1 && isset(UserPermission::where('user_id', Auth::user()->id)->first()->reports)){
            return view('admin.reports.sales.statement');
        }else{
            $permission="'Read Level' permission needed!!!";
            return view('admin.notify.permission_denied', compact('permission'));
        }
        
    }
    public function salesStatementPrint(Request $request)
    {
        if(Auth::user()->getRole->admin==1 || Auth::user()->getRole->read==1 && isset(UserPermission::where('user_id', Auth::user()->id)->first()->reports)){
            // dd(!empty($a));
            $requestData = $request;
            $type=$request->type;
            if ($type=='sales') {
                $dbQuery = SaleInvoice::query();
                if ($request->date_from!='' && $request->date_to!='') {
                    $dbQuery->whereBetween('date', [$request->date_from, $request->date_to]);
                }
                if ($request->client_id!='') {
                    $dbQuery->where('client_id', $request->client_id);
                }
                if ($request->invoice_id!='') {
                    $dbQuery->where('id', $request->invoice_id);
                }
                if ($request->created_by_id!='') {
                    $dbQuery->where('created_by_id', $request->created_by_id);
                }
                $saleInvoice = $dbQuery->get();
                return view('admin.reports.sales.statement_print', compact('saleInvoice', 'requestData'));
            }else{
                $dbQuery = SaleReturnInvoice::query();
                if ($request->date_from!='' && $request->date_to!='') {
                    $dbQuery->whereBetween('date', [$request->date_from, $request->date_to]);
                }
                if ($request->client_id!='') {
                    $dbQuery->where('client_id', $request->client_id);
                }
                if ($request->invoice_id!='') {
                    $dbQuery->where('id', $request->invoice_id);
                }
                if ($request->created_by_id!='') {
                    $dbQuery->where('created_by_id', $request->created_by_id);
                }
                $saleReturnInvoice = $dbQuery->get();
                return view('admin.reports.sales.return_statement_print', compact('saleReturnInvoice', 'requestData'));
            }
        }else{
            $permission="'Read Level' permission needed!!!";
            return view('admin.notify.permission_denied', compact('permission'));
        }
        
    }

    // sales statement end----------------------

    public function salesProductWise()
    {
        if(Auth::user()->getRole->admin==1 || Auth::user()->getRole->read==1 && isset(UserPermission::where('user_id', Auth::user()->id)->first()->reports)){
            return view('admin.reports.sales.product_wise');
        }else{
            $permission="'Read Level' permission needed!!!";
            return view('admin.notify.permission_denied', compact('permission'));
        }
        
    }
    

    public function salesProductWisePrint(Request $request)
    {
        if(Auth::user()->getRole->admin==1 || Auth::user()->getRole->read==1 && isset(UserPermission::where('user_id', Auth::user()->id)->first()->reports)){
            // dd(!empty($a));
            $requestData = $request;
            $dbQuery = Sale::query();
            if ($request->date_from!='' && $request->date_to!='') {
                $dbQuery->whereBetween('date', [$request->date_from, $request->date_to]);
            }
            if ($request->product_id!='') {
                $dbQuery->where('product_id', $request->product_id);
            }
            
            $sale = $dbQuery->get();
            return view('admin.reports.sales.product_wise_print', compact('sale', 'requestData'));
        }else{
            $permission="'Read Level' permission needed!!!";
            return view('admin.notify.permission_denied', compact('permission'));
        }
        
    }
    // sales Product Wise end----------------------


    // sales leaderboard----------------------

    public function salesLeaderboard($flag)
    {
        if(Auth::user()->getRole->admin==1 || Auth::user()->getRole->read==1 && isset(UserPermission::where('user_id', Auth::user()->id)->first()->reports)){
            $dbQuery = SaleInvoice::query();
            if ($flag=='30Days') {
                $date = date('Y-m-d', strtotime('-30 days'));
                $dbQuery->selectRaw('client_id, SUM(COALESCE(payable, 0) - COALESCE(return_amount, 0)) as total')
                    ->where('date', '>=', $date)
                    ->groupBy('client_id')
                    ->orderByDesc('total');
            }elseif ($flag=='currentYear') {
                $currentYear = date('Y');
                $dbQuery->selectRaw('client_id, SUM(COALESCE(payable, 0) - COALESCE(return_amount, 0)) as total')
                    ->whereRaw("YEAR(STR_TO_DATE(date, '%Y-%m-%d')) = ?", [$currentYear])
                    ->groupBy('client_id')
                    ->orderByDesc('total');
            }
            $saleInvoice = $dbQuery->get();
            // dd($saleInvoice);
            return view('admin.reports.sales.leaderboard', compact('saleInvoice', 'flag'));
        }else{
            $permission="'Read Level' permission needed!!!";
            return view('admin.notify.permission_denied', compact('permission'));
        }
        
    }
    // sales leaderboard end----------------------
}
