<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;

use Carbon\Carbon;
use App\Client;
use App\Sale;
use App\SaleInvoice;
use App\SaleReturn;
use App\PurchaseInvoice;
use App\Purchase;
use App\Expense;
use App\Product;
use App\Task;
use Auth;
use App\UserPermission;

// use Nexmo\Laravel\Facade\Nexmo;

class HomeController extends Controller
{
    /**
     * Create a new controller instance.
     *
     * @return void
     */
    public function __construct()
    {
        $this->middleware('auth');
    }

    /**
     * Show the application dashboard.
     *
     * @return \Illuminate\Contracts\Support\Renderable
     */
    public function index()
    {
        
        // Nexmo::message()->send([
        //     'to'   => '8801849609902',
        //     'from' => '8801849609902',
        //     'text' => 'Using the facade to send a message.'
        // ]);

        $today_sale = Sale::whereDate('created_at', Carbon::today())->get();
        $today_stock_out = Sale::whereDate('created_at', Carbon::today())->get();
        $today_stock_in = Purchase::whereDate('created_at', Carbon::today())->get();
        $today_sale_return_count = SaleReturn::whereDate('created_at', Carbon::today())->count();
        $today_expense_count = Expense::whereDate('created_at', Carbon::today())->count();
        $products = Product::all();
            $alert_count=0;
            foreach ($products as $item) {
                if ($item->alert_qty >= $item->stock_qty) {
                    $alert_count++;
                }
            }
        $totla_sale = SaleInvoice::sum('payable');
        $totla_purchase = PurchaseInvoice::sum('payable');
        $client=Client::all();
        $customer_dues = $client->where('type', 'customer')->sum('due');
        $supplier_dues = $client->where('type', 'supplier')->sum('due');
        $saleInvoiceForlineChart=SaleInvoice::whereYear('date', date('Y'))->orderBy('id', 'desc')->get();
        $saleForlineChart=Sale::whereYear('date', date('Y'))->orderBy('id', 'desc')->get();
        $purchaseInvoiceForlineChart=PurchaseInvoice::whereYear('date', date('Y'))->orderBy('id', 'desc')->get();
        $myTask=Task::where('user_id', Auth::user()->id)->get();
        return view('home', compact('today_sale', 
                                    'today_stock_out', 
                                    'today_stock_in', 
                                    'today_sale_return_count', 
                                    'today_expense_count', 
                                    'alert_count', 
                                    'totla_sale', 
                                    'totla_purchase', 
                                    'customer_dues', 
                                    'supplier_dues', 
                                    'saleInvoiceForlineChart', 
                                    'saleForlineChart', 
                                    'purchaseInvoiceForlineChart', 
                                    'myTask', 
                                    'client'));
    }
}
